{
	description = "{{project-name}}";

	inputs = {
		flake-compat.url = "github:edolstra/flake-compat"; flake-compat.flake = false;
		nixpkgs.url      = "github:nixos/nixpkgs/nixos-unstable";
		flake-utils.url  = "github:numtide/flake-utils";
		cargo2nix.url    = "github:cargo2nix/cargo2nix";
		rust-overlay.url = "github:oxalica/rust-overlay";

		cargo2nix.inputs = { nixpkgs.follows = "nixpkgs"; rust-overlay.follows = "rust-overlay"; };
		rust-overlay.inputs = { nixpkgs.follows = "nixpkgs"; flake-utils.follows = "flake-utils"; };
	};

	outputs = { self, nixpkgs, flake-utils, ... }@inputs:
		flake-utils.lib.eachDefaultSystem (system:
			let
				pkgs = import nixpkgs {
					inherit system;
					overlays = [
						inputs.cargo2nix.overlays.default
					];
				};

				rustPkgs = pkgs.rustBuilder.makePackageSet {
					rustChannel = "nightly";
					rustVersion = "2023-08-01";
					extraRustComponents = [ "rust-src" "rustfmt" "rust-analyzer" "clippy" ];
					packageFun = import ./Cargo.nix;
				};

				{{project-name}} = (rustPkgs.workspace.{{project-name}} {}).bin;
			in rec {
				devShells.default = rustPkgs.workspaceShell rec {
					nativeBuildInputs = with pkgs; [
						inputs.cargo2nix.packages.${pkgs.system}.cargo2nix

						rust-analyzer
						cargo-expand

						pkg-config
					];
					buildInputs = with pkgs; [];
					LD_LIBRARY_PATH = pkgs.lib.makeLibraryPath buildInputs;
				};

				packages = {
					inherit {{project-name}};
					default = {{project-name}};
				};

				apps = {
					{{project-name}} = { type = "app"; program = "${packages.{{project-name}}}/bin/{{project-name}}"; };
					default = apps.{{project-name}};
		        };
			}
		);
}
